Subject: Re: [rtcweb] draft-ietf-rtcweb-data-channel failure handling description

From: Michael Tuexen <[email-masked]>
Date: Sun, 28 Sep 2014 23:49:11 +0200

On 16 Aug 2014, at 08:44, Gunnar Hellstrom <[email-masked]> wrote:

> We have discussed the lack of description of failure handling in draft-ietf-rtcweb-data-channel a couple of times.
> 
> Explanations of mechanisms have been provided in mail answers that I have not seen documented elsewhere, but they have not been introduced in the draft.
> 
> I think that for specification and implementation of the WebRTC API, there is a need for clear specification how the channels behave in failure situations.
> 
> I suggest to insert a new chapter 6.7 in the draft with the following contents.  
> 
> -------------------------------------------------------------------Proposed new section 6.7-------------------------------------------------------------------------------------------
> 6.7 Transmission failure and error handling 
> 
> Failures can occur in an open channel by transmission error detection and by SCTP watchdog error indications.
> If transmission in a reliable channel fails, the association where the channel belongs will be aborted. If all retries for a watchdog expires, the corresponding association will be aborted.  All channels in an association that is aborted because of errors need to be closed by the party detecting the failure. Network error indications shall be provided to upper layers on all closed channels.
> 
> If retransmissions or transmission time is exceeded in a partially reliable channel, the transmission SHALL be allowed to continue with other data items. A transmission error indication SHALL be provided to upper layers on that channel. 
> 
> If reception out-of order is detected from an SCTP channel for which ordered transmission is requested, the receiver SHALL close the data channel, and provide an transmission error indication to upper layers.  
> 
> If a message with an unsupported PPID is received or some logical error is detected by the receiver, the receiver SHALL close the corresponding data channel. 
> -----------------------------------------------------------------------end of proposal---------------------------------------------------------------------------------------------------------------
> 
> I am not sure about what the two last kinds of errors should result in and hope that the experts can adjust the wording.
Hi Gunnar,

I think I have covered the contents your are suggesting, but I added some of the text in a section called SCTP Association Management.

Please let me know if the new revision addresses your comments.

Best regards
Michael
> 
> Regards
> 
> Gunnar
> Gunnar Hellström
> Omnitor
> [email-masked]
> 
> On 2014-08-11 20:13, IESG Secretary wrote:
>> The IESG would like to retract the current Last Call on the following 
>> document:
>> 
>> - 'WebRTC Data Channels'
>>   <draft-ietf-rtcweb-data-channel-11.txt> as Proposed Standard
>> 
>> The document's state has been set back to "AD Evaluation."
>> 
>> 
> 
> _______________________________________________
> rtcweb mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtcweb